<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="newRow()" class="btn btn-primary">
    <i class="fas fa-plus mr-2"></i>Nuevo
  </button>
  <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="dataGrid.data.length === 0 || loading">
    <i class="fas fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="card">

  <kendo-grid [data]="dataGrid" [filter]="filter" [filterable]="true" (filterChange)="filterChange($event)"
    [selectable]="true" [navigable]="true" [reorderable]="true" [resizable]="true" [sort]="sort" [sortable]="true"
    (sortChange)="sortChange($event)" [groupable]="true" [group]="groups" (detailExpand)="detailExpand($event)"
    (groupChange)="groupChange($event)" (edit)="editRow($event)" (remove)="deleteRow($event)" style="height: 75vh"
    *ngIf="!loading">

    <ng-template kendoGridDetailTemplate let-dataItem>
      <app-detalle-punto [data]="dataExpand"></app-detalle-punto>
    </ng-template>

    <kendo-grid-column field="Punto" title="Punto" width="200"></kendo-grid-column>
    <kendo-grid-column field="pdesc" title="Descripción" width="250"></kendo-grid-column>
    <kendo-grid-column field="codigo" title="Cod." width="120" [filterable]="false"></kendo-grid-column>
    <kendo-grid-column field="plinea" title="Linea F-O" width="120" [filterable]="false">
      <ng-template kendoGridFilterCellTemplate>
        <kendo-switch (valueChange)="switchChange($event)" offLabel="No" [checked]="checked" onLabel="Si">
        </kendo-switch>
      </ng-template>
      <ng-template kendoGridCellTemplate let-dataItem>
        <input type="checkbox" [checked]="dataItem.plinea" disabled />
      </ng-template>
    </kendo-grid-column>
    <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
      <ng-template kendoGridFilterCellTemplate>
        <kendo-switch (valueChange)="switchChange($event)" offLabel="No" [checked]="checked" onLabel="Si">
        </kendo-switch>
      </ng-template>
      <ng-template kendoGridCellTemplate let-dataItem>
        <input type="checkbox" [checked]="dataItem.Inactivo" disabled />
      </ng-template>
    </kendo-grid-column>
    <kendo-grid-command-column title="Actions" width="190">
      <ng-template kendoGridCellTemplate let-isNew="isNew" let-dataItem>
        <button kendoGridEditCommand [primary]="true">Editar</button>
        <button kendoGridRemoveCommand>Eliminar</button>
      </ng-template>
    </kendo-grid-command-column>
  </kendo-grid>

  <ng-template #modal let-c="close" let-d="dismiss" class="animated flipInX">
    <div class="modal-header">
      <h6 *ngIf="!flagEdit">Nuevo Punto</h6>
      <h6 *ngIf="flagEdit">Actualizar Punto</h6>
    </div>
    <form [formGroup]="myFormGroup" class="k-form">
      <kendo-tabstrip [tabPosition]="'top'">
        <kendo-tabstrip-tab title="General" [selected]="true">
          <ng-template kendoTabContent>
            <div class="row">
              <label class="k-form-field col-2">
                <span>Punto</span>
                <input type="number" class="k-textbox" formControlName="Punto" [readOnly]="flagEdit"
                min="0" max="999">
              </label>
              <label class="k-form-field col-6">
                <span>Descripción</span>
                <input class="k-textbox" formControlName="pdesc" maxlength="30">
              </label>
              <label class="k-form-field col-2">
                <span>Inactivo</span>
                <kendo-switch formControlName="Inactivo" [onLabel]="'Si'" [offLabel]="'No'">
                </kendo-switch>
              </label>
              <label class="k-form-field col-2">
                <span>Linea F-O</span>
                <kendo-switch formControlName="plinea" [onLabel]="'Si'" [offLabel]="'No'">
                </kendo-switch>
              </label>
              <label class="k-form-field col-4">
                <span>Código</span>
                <kendo-combobox [data]="dsCodigos" [textField]="'cdesc'" [valueField]="'Codigo'"
                  formControlName="codigo" [valuePrimitive]="true" class="w-100">
                </kendo-combobox>
              </label>
              <label class="k-form-field col-4">
                <span>Ing. Agrupado</span>
                <kendo-combobox [data]="dsIngAgrupados" [textField]="'cDesc'" [valueField]="'iagrp'"
                  formControlName="iagrp" [valuePrimitive]="true" class="w-100">
                </kendo-combobox>
              </label>
              <label class="k-form-field col-4">
                <span>Imagen de Plano</span>
                <input type="text" class="k-textbox" name="imagenPlano" [(ngModel)]="imagenPlano"
                  [ngModelOptions]="{standalone: true}">
              </label>

              <label class="k-form-field col-4">
                <span>Impresora</span>
                <input type="text" class="k-textbox" formControlName="cImpresora" maxlength="50">
              </label>
              <label class="k-form-field col-4">
                <span>Clase</span>
                <kendo-combobox [data]="dsClases" [textField]="'cdesc'" [valueField]="'clase'" formControlName="Clase"
                  [valuePrimitive]="true" class="w-100">
                </kendo-combobox>
              </label>
              <label class="k-form-field col-2">
                <span>Nombre</span>
                <kendo-switch formControlName="pnombre" [onLabel]="'Si'" [offLabel]="'No'">
                </kendo-switch>
              </label>
              <label class="k-form-field col-2">
                <span>Comanda Aut.</span>
                <kendo-switch formControlName="pcomanda" [onLabel]="'Si'" [offLabel]="'No'">
                </kendo-switch>
              </label>
              <label class="k-form-field col-2">
                <span>Porc. Servicio</span>
                <input type="number" class="k-textbox" formControlName="pprop" min="0" max="999">
              </label>
              <label class="k-form-field col-2">
                <span>Servicio con impuestos</span>
                <kendo-switch formControlName="ppimp" [onLabel]="'Si'" [offLabel]="'No'">
                </kendo-switch>
              </label>
              <label class="k-form-field col-2">
                <span>Validar Mesa</span>
                <kendo-switch formControlName="pvalmes" [onLabel]="'Si'" [offLabel]="'No'">
                </kendo-switch>
              </label>
              <label class="k-form-field col-2">
                <span># Turnos</span>
                <input type="number" class="k-textbox" formControlName="pnturnos" min="0" max="999">
              </label>
              <label class="k-form-field col-2">
                <span>Max. Dias Reserv.</span>
                <input type="number" class="k-textbox" formControlName="pdias" min="0" max="999">
              </label>
              <label class="k-form-field col-2">
                <span>Max. Reserv. Estancia</span>
                <input type="number" class="k-textbox" formControlName="pmre" min="0" max="999">
              </label>
            </div>
          </ng-template>
        </kendo-tabstrip-tab>
        <kendo-tabstrip-tab title="Notas">
          <ng-template kendoTabContent>
            <div class="row d-flex justify-content-center">
              <div class="form-group col-6">
                <label for="pnotas1">Notas para Facturas o Tickets</label>
                <textarea class="form-control" rows="1" formControlName="pnotas1" maxlength="200">
                                                </textarea>
              </div>
              <div class="form-group col-6">
                <label for="pnotas2">Notas para Confirmación</label>
                <textarea class="form-control" rows="1" formControlName="pnotas2" maxlength="200">
                                                </textarea>
              </div>
              <label class="k-form-field col-3">
                <span>Notas Alimentos</span>
                <kendo-switch formControlName="pnc1" [onLabel]="'Si'" [offLabel]="'No'">
                </kendo-switch>
              </label>
              <label class="k-form-field col-9">
                <span>Impresora Alimentos</span>
                <kendo-combobox [data]="dsImpresoras" [textField]="'impresora'" [valueField]="'impresora'"
                  formControlName="pic1" [valuePrimitive]="true" class="w-100">
                </kendo-combobox>
              </label>
              <label class="k-form-field col-3">
                <span>Notas Bebidas</span>
                <kendo-switch formControlName="pnc2" [onLabel]="'Si'" [offLabel]="'No'">
                </kendo-switch>
              </label>
              <label class="k-form-field col-9">
                <span>Impresora Bebidas</span>
                <kendo-combobox [data]="dsImpresoras" [textField]="'impresora'" [valueField]="'impresora'"
                  formControlName="pic2" [valuePrimitive]="true" class="w-100">
                </kendo-combobox>
              </label>
              <label class="k-form-field col-3">
                <span>Notas Varios</span>
                <kendo-switch formControlName="pnc3" [onLabel]="'Si'" [offLabel]="'No'">
                </kendo-switch>
              </label>
              <label class="k-form-field col-9">
                <span>Impresora Varios</span>
                <kendo-combobox [data]="dsImpresoras" [textField]="'impresora'" [valueField]="'impresora'"
                  formControlName="pic3" [valuePrimitive]="true" class="w-100">
                </kendo-combobox>
              </label>
            </div>
          </ng-template>
        </kendo-tabstrip-tab>
        <kendo-tabstrip-tab title="Clases">
          <ng-template kendoTabContent>
            <kendo-grid [data]="dataDetail" [selectable]="true" [navigable]="true" [resizable]="true">
              <kendo-grid-column field="cCdesc" title="Clase"></kendo-grid-column>
              <kendo-grid-column field="pscheq" title="# Cheque"></kendo-grid-column>
            </kendo-grid>
          </ng-template>
        </kendo-tabstrip-tab>
      </kendo-tabstrip>
    </form>
    <div class="modal-footer">
      <button class="btn btn-primary" (click)="c('Close click')">
        Cerrar
      </button>
      <button class="btn btn-success ml-1" [disabled]="myFormGroup.invalid" (click)="guardarForm()">
        <i class="fas fa-save mr-2"></i>Guardar
      </button>
    </div>
  </ng-template>
</div>

<app-loading *ngIf="loading"></app-loading>
